/* EPITA - IP - S3/4 */
/* question17 */


# include "question17.h"

void get_status(char *cmd, char **args, struct status *status) {
  int istatus;
  pid_t pid = fork();
  if (pid == -1)
    err(3, "can't fork");
  if (pid != 0) {
    waitpid(pid, &istatus, 0);
    if (WIFEXITED(istatus)) {
      status->exited = 1;
      status->exit_status = WEXITSTATUS(istatus);
    } else {
      status->exited = 0;
      status->kill_signal = WTERMSIG(istatus);
    }
    return;
  } else {
    execvp(cmd, args);
    err(3, "execution of %s failed", cmd);
  }
}
