/* EPITA - IP - S3/4 */
/* question02 */

#define QNUM 2
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question02.h"

static inline
int check_sqrt(unsigned long n, unsigned long x) {
  return x * x <= n && n < (x + 1) * (x + 1);
}

static
void fixed_tests(void) {
  printf("Fixed tests:\n");
  { unsigned long n = 0;
    unsigned long x = my_intsqrt(n);
    printf("\tmy_intsqrt(%5lu) \t= %6lu \t[%s]\n", n, x, check(x == n));
    n = 1; x = my_intsqrt(n);
    printf("\tmy_intsqrt(%5lu) \t= %6lu \t[%s]\n", n, x, check(x == n));
  }
  for (unsigned long i = 1; i < 9; i++) {
    unsigned long n = 1 << (i * 2);
    unsigned long x = my_intsqrt(n);
    printf("\tmy_intsqrt(%5lu) \t= %6lu \t[%s]\n", n, x, check(x == (1 << i)));
  }
}

static
void random_test(size_t len) {
  printf("Random tests:\n");
  for (size_t i = 0; i < len; i++) {
    unsigned long n = random();
    unsigned long x = my_intsqrt(n);
    printf("\tmy_intsqrt(%10lu)\t= %6lu \t[%s]\n", n, x,
           check(check_sqrt(n, x)));
  }
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_tests();
      random_test(size);
    }
  exit(0);
}
