/* EPITA - IP - S3/4 */
/* question04 */

#define QNUM 4
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question04.h"

static
void random_fill(int *begin, int *end) {
  for (; begin < end; begin++)
    *begin = random() % 1000;
}

static
int* hill_fill(int *begin, int *end) {
  ssize_t len = end - begin;
  size_t top = random() % len;
  int *cur = begin;
  for (int i = 0; cur < begin + top; cur++, i++)
    *cur = i;
  for (int i = top; cur < end; cur++, i--)
    *cur = i;
  return begin + top;
}

static
void print_array(int *begin, int *end) {
  for (; begin < end; begin++) {
    printf("| %3d ", *begin);
  }
  printf("|\n");
}

static
void fixed_test(size_t len) {
  printf("Hill array tests:\n");
  int *tab = malloc(len * sizeof (int));
  int *top = hill_fill(tab, tab + len);
  printf("  array:\n    ");
  print_array(tab, tab + len);
  int *rtop = array_top(tab, tab + len);
  if (rtop && rtop >= tab && rtop < tab + len)
    printf("array_top(begin, end) = %d (%s)\n", *rtop, check(top == rtop));
  else
    printf("array_top(begin, end) returned NULL or out-of-range pointer (%s)\n", check(rtop == top));
  free(tab);
}

static
void random_test(size_t len) {
  printf("Random tests:\n");
  int *tab = malloc(len * sizeof (int));
  random_fill(tab, tab + len);
  printf("  array:\n    ");
  print_array(tab, tab + len);
  int *rtop = array_top(tab, tab + len);
  if (rtop < tab && rtop >= tab + len) {
    printf("array_top(begin, end) returned out-of-range pointer\n");
    free(tab);
    return;
  }
  if (rtop)
    printf("array_top(begin, end) = %d\n", *rtop);
  else
    printf("array_top(begin, end) returned NULL\n");
  free(tab);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
      random_test(size);
    }
  exit(0);
}
