/* EPITA - IP - S3/4 */
/* question10 */

#define QNUM 10
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stddef.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question10.h"


static
void print_list(struct list *list, const char *prefix) {
  int line, base;
  base = line = printf("%s =", prefix);
  if (list->next == NULL) {
    printf(" EMPTY\n");
    return;
  }
  for (struct list *cur = list; cur->next; cur = cur->next) {
    if (line > 72) {
      printf("\n%*s", base, "");
      line = base;
    }
    line += printf(" -> %3d", cur->next->val);
  }
  printf("\n");
}

static inline
void f(struct list *list, struct list *elm) {
  elm->next = list->next;
  list->next = elm;
}

static
void build_list(struct list *list, struct list* store, size_t len, int start, int step) {
  struct list *last = list;
  for (size_t i = 0; i < len; i++, start += step) {
    (store + i)->val = start;
    f(last, store + i);
    last = last->next;
  }
}

void zero_memset(void *mem, size_t len) {
  for (char *cur = mem; cur < ((char*)mem) + len; cur++)
    *cur = 0;
}

static
void seq_test(struct list *store, size_t len) {
  printf("  Sequentence test:\n");
  zero_memset(store, (len + 1) * 2 * sizeof (struct list));
  struct list *l1, *l2;
  l1 = store;
  build_list(l1, store + 1, len, 1, 1);
  l2 = store + len + 1;
  build_list(l2, store + len + 2, len, len + 1, 1);
  print_list(l1, "l1");
  print_list(l2, "l2");
  printf("list_merge(l1, l2)");
  list_merge(l1, l2);
  print_list(l1, "l1");
}

static
void fixed_test(size_t len) {
  printf("Tests:\n");
  struct list *store;
  store = calloc((len + 1) * 2 + 1, sizeof (struct list));
  seq_test(store, len);
  free(store);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
    }
  exit(0);
}
