/* EPITA - IP - S3/4 */
/* question14 */

#define QNUM 14
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question14.h"


static
struct tree* build_tree(size_t depth, int *k, struct tree *store, size_t *idx) {
  struct tree *tree = store + *idx;
  *idx += 1;
  tree->key = *k;
  *k += 1;
  tree->left = tree->right = NULL;
  if (depth) {
    tree->left = build_tree(depth - 1, k, store, idx);
    tree->right= build_tree(depth - 1, k, store, idx);
  }
  return tree;
}

static
void print_tree(struct tree *tree, int pad) {
  if (tree) {
    printf("%*s<%d", pad, "", tree->key);
    if (tree->left) {
      printf("\n");
      print_tree(tree->left, pad + 2);
    }
    if (tree->right) {
      printf("\n");
      print_tree(tree->right, pad + 2);
    }
    if (tree->left != tree->right)
      printf("\n%*s", pad, "");
    printf(">");
  }
}

static
void random_test(size_t len) {
  printf("Random Tests:\n");
  struct tree *store = calloc(1<<(len+1), sizeof (struct tree));
  struct tree *tree;
  size_t idx = 0;
  int k = 0;
  tree = build_tree(len, &k, store, &idx);
  printf("tree =\n");
  print_tree(tree, 2);
  printf("\n");
  size_t size = tree_size(tree);
  printf("tree_size(tree) = %zu - [%s]\n", size, check(size == (size_t)k));
  free(store);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      random_test(size);
    }
  exit(0);
}
